/** Lab 7 SO - Memoria virtuala */
/** Demo Windows */

#include <stdio.h>
#include <assert.h>
#include <limits.h>
#include <windows.h>

static int pageSize = 0x1000;

/* pointer la o functie cu un parametru intreg si care intoarce un intreg */
int (*dyncode)(int);

/* array de tip char initializat cu un cod ce va lua parametrul
de pe stiva, il va incrementa si va intoarce valoarea */
unsigned char code[] = {0x8B,0x44,0x24,0x04,  /* mov eax, [esp+4] */ 
                        0x40,                 /* inc eax          */ 
                        0xC3                  /* ret              */ 
                       }; 

int main() 
{ 
        /* desi codul e definit static mai sus, el va fi copiat intr-o zona de memorie
		alocata cu VirtualAlloc pt a demonstra ca orice cod generat dinamic poate
		fi tratat astfel */
		
        dyncode = (int (*)(int)) VirtualAlloc(NULL, pageSize,
			MEM_COMMIT, PAGE_EXECUTE_READWRITE);

        memcpy(dyncode, code, sizeof(code)); 

        printf("valoare intoarsa = %d\n", (*dyncode)(2));

        VirtualFree(dyncode, 0, MEM_RELEASE);
        return 0;
}
